
    #define F_CPU 1000000UL


    
    #include <avr/io.h>  
    #include <stdio.h>  
    #include <stdlib.h>  
    #include <util/delay.h>
    

      
 
    void init_pwm () {
	// timer 1 (PWM)
	TCNT1 = 0; // timer count
	OCR1A = 0; // compare A - pwm0
	OCR1B = 0; // compare B - pwm1
	TCCR1A = (1<<COM1A1) | (1<<COM1B1) | (1<<WGM11) | (1<<WGM10); // fast PWM
	TCCR1B = (1<<CS10); 

	// timer 2 (PWM)
	TCNT2 = 0; // timer count
	OCR2 = 0; // compare A	- pwm2
	TCCR2 = (1<<COM21) | (1<<WGM20) | (1<<CS20); // fast PWM 8bit
    }
      
    int main(void)    
    {  
 
	unsigned char pwm0 = 0, pwm1 = 0, pwm2 = 0;
	DDRD=0x00;              //nastaveni jak vstup  
	PORTD=0xFF;             //nastaveni pull-up rezistoru

	DDRB=0x00;
	
	init_pwm();


	while (1) {	//testujeme a svitime furt dokola...
		
		if(pwm0!=255){
		if(!(PIND&(1<<PD0))) 
		{
		pwm0+=5;	
		_delay_ms(50);
        }}

        if(pwm0!=0){
		if(!(PIND&(1<<PD1))) 
		{
		pwm0-=5;	
		_delay_ms(50);
        }}

		
	if(pwm1!=255){
		if(!(PIND&(1<<PD2))) 
		{
		pwm1+=5;	
		_delay_ms(50);
        }}

        if(pwm1!=0){
		if(!(PIND&(1<<PD3))) 
		{
		pwm1-=5;	
		_delay_ms(50);
        }}


	if(pwm2!=255){
		if(!(PIND&(1<<PD4))) 
		{
		pwm2+=5;	
		_delay_ms(50);
        }}

        if(pwm2!=0){
		if(!(PIND&(1<<PD5))) 
		{
		pwm2-=5;	
		_delay_ms(50);
        }}
		
		// tuto je tu aby if pwm==0 nesvitilo nic (jinak malinko sviti furt...)
		if (pwm0) {
			OCR1A = pwm0;
			DDRB |= (1<<PB1);
		} else {
			DDRB &= ~(1<<PB1);
		}
		if (pwm1) {
			OCR1B = pwm1;
			DDRB |= (1<<PB2);
		} else {
			DDRB &= ~(1<<PB2);
		}
		if (pwm2) {
			OCR2 = pwm2;
			DDRB |= (1<<PB3);
		} else {
			DDRB &= ~(1<<PB3);
		}
	}

}
